/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


EXPORTED_SYMBOLS.push(
    "ttPOI",
    "ttSafetyCams"
);
function ttPOI()
{
    ttNavItem.apply(this);
}
ttPOI.prototype =
{
    _poiCount : null,

    _listEntry :
    {
        modelType : ttPOI,
        xmlTag : "poi",
        tocTag : "Poi",
        priority : 140,
        itemtypeEnum : CI.ttIItem.kItemPOIs,
        idlType : CI.ttINavItem
    },
    importFromXML : function(xml)
    {
        ttNavItem.prototype.importFromXML.apply(this, arguments);

        if ("poicount" in xml)
            this._poiCount = makeSafe.integer(xml.poicount);
    },
get poiCount()
    {
        return this._poiCount;
    },
    __end : null
}
extend(ttPOI, ttNavItem);
AddSubtypeV1(ttPOI.prototype._listEntry);
function ttSafetyCams()
{
    ttPOI.apply(this);
    ttSubscription.apply(this);
}
ttSafetyCams.prototype =
{
    _listEntry :
    {
        modelType : ttSafetyCams,
        xmlTag : "safetycamera",
        tocTag : "Poi",
        tocSubtype : "safetycamera",
        priority : 130,
        itemtypeEnum : CI.ttIItem.kItemSafetyCamera,
        idlType : CI.ttINavItem
    },
    importFromXML : function()
    {
        ttPOI.prototype.importFromXML.apply(this, arguments);
        ttSubscription.prototype.importSubscriptionFromXML.apply(this, arguments);
    },
    __end : null
}
extend(ttSafetyCams, ttPOI);
extendMixIn(ttSafetyCams, ttSubscription);
AddSubtypeV1(ttSafetyCams.prototype._listEntry);
