/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


EXPORTED_SYMBOLS.push("ttSubscription");
function ttSubscription()
{
}

ttSubscription.prototype = 
{
    _expires : null,
    _userIsOrWasSubscribed : false,

    importSubscriptionFromXML : function(xml)
    {
        if ("subscription" in xml)
        {
            this._expires = makeSafe.date(xml.subscription.@expires);
        }
    },

    get daysLeft()
    {
        if (this._expires){
            return Math.floor((this._expires.getTime() - Date.now()) / (1000 * 3600 * 24));
        }
        return null;
    },

    get userIsOrWasSubscribed()
    {
        return this._expires != null;
    }
}
