/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/

EXPORTED_SYMBOLS.push("ttImage");
function ttImage(url, mimetype, width, height)
{
  this.url = url;
  this.mimetype = mimetype;
  this.width = width;
  this.height = height;
}
ttImage.prototype =
{
  url : null,
  mimetype : null,
  width : null,
  height : null,
createFromServer : function(xml)
  {
    var result = new ttImage();
    result.url = makeSafe.url(xml.@url, rpc.contentBaseURI()).spec;
    result.mimetype = makeSafe.mimetype(xml.@mimetype, 1);
    if ("@width" in xml)
        result.width = makeSafe.integer(xml.@width);
    if ("@height" in xml)
        result.height = makeSafe.integer(xml.@height);
    return result;
  },

  createFromDLL : function(nsifile)
  {
    var result = new ttImage();
    result.url = getIOService().newFileURI(nsifile).spec;
    result.mimetype = null;
    result.width = null;
    result.height = null;
    return result;
  },
  toString : function()
  {
    return "Image <" + this.url + "> mimetype:" + this.mimetype +
        " w:" + this.width + " h:" + this.height;
  },

  exportToXML : function()
  {
    var xml = <image/>;
    xml.@url = this.url;
    if (this.mimetype)
        xml.@mimetype = this.mimetype;
    if (this.width)
        xml.@width = this.width;
    if (this.height)
        xml.@height = this.height;
    return xml;
  },
  end : null
}
