/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


window.onload = function()
{
    var dashboard = E("add-to-my-go");
    if (dashboard)
    {
        var origRefresh = dashboard.refreshDeviceDependencies;
        dashboard.refreshDeviceDependencies = function()
        {
            origRefresh.apply(this, arguments);
            updateDocumentButton(dashboard);
        }
        updateDocumentButton(dashboard);
    }
}
function addMessageLaunch(type)
{
    if (gApplication.deviceManager.activeDevice)
    {
        top.gMainWindow.dialogs.openDialogAsPage(
            "chrome://tthome/content/ui/dialogs/info/addgoPage.xul",
            { type : type });
        return;
    }

    top.gMainWindow.dialogs.openDialogAsPage(
        top.gMainWindow.dialogs.kDeviceRequiredPage,
        null,
        null,
    function()
    {
        if (gApplication.deviceManager.activeDevice)
        {
            top.gMainWindow.dialogs.openDialogAsPage(
                "chrome://tthome/content/ui/dialogs/info/addgoPage.xul",
                { type : type });
        }
    }, false, top);
}

function buyAndInstallTTSVoiceLaunch()
{
    var dev = gApplication.deviceManager.activeDevice;
    if (!dev)
    {
        var sb = getStringBundle("chrome://tthome/locale/ui/dashboard/dashboard.properties");
        ttMessageService().alert(sb.GetStringFromName("needDevice.title"), sb.GetStringFromName("needDevice.text"));
        return;
    }
    var supportsLoquendo = dev.hasCapability("TTSLoquendo*");
    var supportsNuance = dev.hasCapability("TTSNuance*");
    var params = { contentType : null };

    if (supportsLoquendo && supportsNuance)
    {
var caps = gApplication.deviceManager.activeDeviceCapabilitiesString;
        if (caps.indexOf("TTSLoquendo") < caps.indexOf("TTSNuance"))
            params.contentType = "loquendovoice";
        else
            params.contentType = "vocalizervoice";
    }
    else if (supportsLoquendo)
        params.contentType = "loquendovoice";
    else if (supportsNuance)
        params.contentType = "vocalizervoice";
    else
        throw new NotReached("Have neither Loquendo nor Nuance voice capability.");

    top.gMainWindow.loadTaskByName("buyAndInstall", params);
}

function updateDocumentButton(dashboard)
{
    var canUseDocuments = true;
    var installLoc = gApplication.deviceManager.activeInstallLocation;
    if (installLoc)
    {
        var path = installLoc.path.path;
        if (path.indexOf("\\\\{") == 0 && path.indexOf("}") > 0)
        {
            canUseDocuments = false;
        }
    }

    if ("content-list-documents" in dashboard.buttonsById)
    {
        var button = dashboard.buttonsById["content-list-documents"];
        if (button.getAttribute("disabled") == "true")
            return;

        button.setAttribute("disabled", !canUseDocuments);
        if (!canUseDocuments && !button.hasAttribute("clickdisabled"))
        {
            button.setAttribute("clickdisabled", "this._unsupportedCapability()");
        }
    }
}

function audiobooksLaunch()
{
    top.gMainWindow.dialogs.openDialogAsPage(
        "chrome://tthome/content/ui/dialogs/audiobook/audiobook.xul");
}

function subdashGoBack()
{
    top.gMainWindow.loadContent(window.getChromeArg("return"));
}
