/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


var gEnableDialogDeviceObserver =
{
    changed : function(deviceChanged, locationChanged)
    {
        if (deviceChanged)
            dialog.close();
    }
};
function NYEnableDialog()
{
    ttDialog.call(this, "footer");
}
NYEnableDialog.prototype =
{
    onLoad: function(params)
    {
        var dev = gApplication.deviceManager.activeDevice;

        if (!dev)
        {
            E("device-connected").hidden = false;
            E("footer").setAttribute("rightdisabled", "true");
            return;
        }

        if (!dev.mapShare)
        {
            E("mapshare-not-supported").hidden = false;
            E("footer").setAttribute("rightdisabled", "true");
            return;
        }

        if (dev.mapShare.mapPatchDownloadsEnabled)
        {
            E("mapshare-enabled").hidden = false;
            E("footer").setAttribute("rightdisabled", "true");
            return;
        }

        E("mapshare-invitation").hidden = false;

        gApplication.deviceManager.addObserver(gEnableDialogDeviceObserver);
    },

    join : function()
    {
        try {
            E("footer").setAttribute("rightdisabled", "true");

            gApplication.deviceManager.activeDevice.mapShare.mapPatchDownloadsEnabled = true;

            this.close();
            let wnd = this.openerWindow;
            let gMainWindow = top.gMainWindow;
            runAsync(function()
            {
                gMainWindow.dialogs.openDialogAsWindow(
                    "chrome://tthome/content/ui/dialogs/NY/enableConfirm.xul",
                    null, null, null, true, wnd);
            });
        } catch (e)  {
            error(e);
        }
    },

    close : function()
    {
        gApplication.deviceManager.removeObserver(gEnableDialogDeviceObserver);
        ttDialog.prototype.close.apply(this, arguments);
    },

    __end : null
}
extend(NYEnableDialog, ttDialog);
var dialog = new NYEnableDialog();
