/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


var helpBrowser;
var context = null;

function onLoad()
{
    helpBrowser = E("help-content");
    helpBrowser.addProgressListener(helpListener);

    try {
        context = window.arguments[0];
    }
    catch(e) {}
    if (context && context != "")
    {
        goHome();
        loadContext(context, true);
    }
    else
    {
        goHome();
    }
   getWebNavigation().sessionHistory =
        Cc["@mozilla.org/browser/shistory;1"]
                  .createInstance(CI.nsISHistory);
}

function getHomeUrl()
{
    var mainwin = getMainWindowByType();
    var helppath = mainwin.gApplication.settings.installDir;
    helppath.append("helpcontent");
    helppath.append("help.jar");

    var hUrl;
    if (helppath.exists())
    {
        var locale = mainwin.gApplication.settings.uiLocale;
        if (locale == "nl-BE")
            locale = "nl-NL";
        var path = "/" + locale + "/index.html";
        hUrl = getIOService().newFileURI(helppath);
        hUrl = getIOService().newURI("jar:" + hUrl.spec + "!" + path, null, null);
    }
    else
    {
        helppath = helppath.parent;
        helppath.append(mainwin.gApplication.settings.uiLocale);
        helppath.append("index.html");

        hUrl = getIOService().newFileURI(helppath);
    }
return hUrl.spec;
}

function goHome()
{
    var fileUrl = getHomeUrl();
    loadPage(fileUrl);
}

function loadPage(filepath)
{
    getWebNavigation().loadURI(filepath,
                               Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,
                               null, null, null);
}

function loadContext(context, force)
{
    if (context != "")
    {
        var fileUrl = getHomeUrl() + "?" + context+".htm";
        loadPage(fileUrl);
    }
}

function getWebNavigation()
{
    try
    {
        return helpBrowser.webNavigation;
    }
    catch (e)
    {
        return null;
    }
}

function goBack()
{
    try
    {
        getWebNavigation().goBack();
    }
    catch (e) { }
}

function goForward()
{
    try
    {
      getWebNavigation().goForward();
    }
    catch(e) { }
}

function print()
{
    try
    {
        helpBrowser.contentWindow.frames[1].print();
    }
    catch (e) { }
}

function done()
{
  window.close();
}

function UpdateBackForwardButtons() {
    var backBroadcaster = document.getElementById("canGoBack");
    var forwardBroadcaster = document.getElementById("canGoForward");
    var webNavigation = getWebNavigation();

    var backDisabled = (backBroadcaster.getAttribute("disabled") == "true");
    var forwardDisabled = (forwardBroadcaster.getAttribute("disabled") == "true");

    if (backDisabled == webNavigation.canGoBack) {
      if (backDisabled)
        backBroadcaster.removeAttribute("disabled");
      else
        backBroadcaster.setAttribute("disabled", true);
    }

    if (forwardDisabled == webNavigation.canGoForward) {
      if (forwardDisabled)
        forwardBroadcaster.removeAttribute("disabled");
      else
        forwardBroadcaster.setAttribute("disabled", true);
    }
}
var helpListener = {

  QueryInterface: function(aIID) {
    if (aIID.equals(Components.interfaces.nsIWebProgressListener)   ||
        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
        aIID.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },

  onLocationChange: function(aProgress, aRequest, aURI) {
    UpdateBackForwardButtons();
  },

  onStateChange: function(wp, req, state, status) {  },
  onProgressChange: function() {  },
  onStatusChange: function() {  },
  onSecurityChange: function() {  }
}
