/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


window.addEventListener("load", initBannerDisplay, false);

function BannerDisplay()
{
    this._bannerFrame = E("bannerFrame");
    DocumentWebProgressListener.call(this, this._bannerFrame);
}
BannerDisplay.prototype =
{
    changed : function(aBannerURL)
    {
if (!aBannerURL || this._bannerFrame.getAttribute("src") == aBannerURL)
            return;

        this._bannerFrame.hidden = true;
        this._bannerFrame.setAttribute("src", aBannerURL);
        this._bannerFrame.docShell.allowJavascript = false;
        this._bannerFrame.docShell.allowAuth  = false;
        this._bannerFrame.docShell.allowMetaRedirects  = false;
        this._bannerFrame.docShell.allowPlugins  = false;
        this._bannerFrame.docShell.allowSubframes  = false;
    },

    loaded : function()
    {
        try {
            this._bannerFrame.hidden = false;
        } catch (e) {
}
    }
}
extend(BannerDisplay, DocumentWebProgressListener);

function initBannerDisplay()
{
var bannerManager = top.gMainWindow.bannerManager;
    var bannerDisplay = new BannerDisplay();
    bannerManager.addObserver(bannerDisplay);
    window.addEventListener("unload", function ()
        {
            try {
                top.gMainWindow.bannerManager.removeObserver(bannerDisplay);
                bannerDisplay.destructor();
            } catch (e) { unimportantError(e); }
        }, false);
    try {
        if (bannerManager.bannerDataURI != null)
        {
            bannerDisplay.changed(bannerManager.bannerDataURI);
            bannerManager.refetchIfTimedout();
        }
    } catch (e) { unimportantError(e); }
}
