/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function AddonUpdatePage()
{
    ttPage.apply(this, arguments);
}

AddonUpdatePage.prototype =
{
    _listbox : null,

    inputOnLoad : function(startup)
    {
        var wizard = this._wizard();
        if (startup)
        {
            var sb = getStringBundle("chrome://tthome/locale/ui/subtask/addonUpdate/addonUpdate.properties");

            var leftButton = wizard._wizfooter.getLeftButton();
            leftButton.label = sb.GetStringFromName("abort_install.label");

            var middleButton = wizard._wizfooter.getMiddleButton();
            middleButton.label = sb.GetStringFromName("install_later.label");
            middleButton.oncommand = makeCallback(this, this.remindLater);
            middleButton.notvisible = false;
        }
        else
            wizard._wizfooter.getMiddleButton().notvisible = true;

        this.allowContinue(false);

        this._listbox = E("listbox");
        this._listbox.addObserver(this);
    },

    inputStart : function(itemlist)
    {
        this._listbox.addItemList(itemlist);
    },

    inputDone : function()
    {
        this.updateContinueButton();
    },

    addedListItem : function(listitem)
    {
        if (!listitem.disabled)
            listitem.selected = true;

        listitem.addToggleButton(null, null,
                                 makeCallback(this, this.updateContinueButton),
                                 makeCallback(this, this.updateContinueButton));
    },

    remindLater : function()
    {
        prefService().setBoolPref("extensions.update.notifyUser", true);
        this._wizard().goBack();
    },

    updateContinueButton : function()
    {
        this.allowContinue(this.result().length > 0);
    },

    result : function()
    {
        return this._listbox.selectedModelitems;
    }
};

extend(AddonUpdatePage, ttPage);
window.page = new AddonUpdatePage();
