/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function OrderOverview()
{
    ttPage.apply(this, arguments);
}

OrderOverview.prototype =
{
    _termsConditionsRadio : null,
    _companyYesNo : null,
    _sb : null,
    _companyData : null,

    inputOnLoad: function (data)
    {
        this.allowContinue(false);
        this._sb = E('stringbundle');

        E("total-amount").value = gApplication.cart.totalPrice.displayString();

        var listbox = E("cartcontent");
        listbox.addObserver(this);
        var itemList = new ttItemList();
        itemList.addFilter(new ttDependencyTreeBuilder());
        listbox.addItemList(itemList);
        var cartArray = gApplication.cart.contentsFlat;
        for (var i = 0; i < cartArray.length; i++)
        {
            itemList.addItem(cartArray[i]);
        }

        this._companyYesNoLabel = E("companyYesNo");
        this._companyYesNoLabel.addEventListener(
            "click",
            makeCallback(this, this.toggleCompanyInput),
            false
        );

        this._termsConditionsRadio = E("acceptTermsConditions");
        this._termsConditionsRadio.addEventListener("click", function()
            {
                if (!this.disabled)
                    this.checked = !this.checked;
            }, false);
        this._termsConditionsRadio.addEventListener("CheckboxStateChange",
            makeCallback(this, this.toggleAgree),
            false);

        setTermsAndConditionsLink(E("readTermsConditions"), this._sb);
    },

    inputDone : function(data)
    {
        this._companyData = data;
        E("companyName").value = this._companyData.server.company;
        E("vatCode").value = this._companyData.server.vatcode;
        E("confirmation-message").value = this._sb.getFormattedString("confirmationMessage", [gApplication.login.currentUsername]);
        this.toggleAgree(null);
    },

    result : function()
    {
       E("acceptTermsConditions").disabled = true;
       this._companyData.isForCompany = E("companyGrid").getAttribute("class") == "gridVisible";
       this._companyData.local.company = E("companyName").value;
       this._companyData.local.vatcode = E("vatCode").value;
       return this._companyData;
    },

    toggleCompanyInput : function()
    {
        var companyGrid = E("companyGrid");
        if (companyGrid.getAttribute("class") == "gridHidden")
        {
            companyGrid.setAttribute("class", "gridVisible");
            this._companyYesNoLabel.value = this._sb.getString("companyYesNo.no.label");
        } else {
            companyGrid.setAttribute("class","gridHidden");
            this._companyYesNoLabel.value = this._sb.getString("companyYesNo.yes.label");
        }
    },

    toggleAgree: function (event)
    {
        this.allowContinue(E("acceptTermsConditions").checked && this._companyData);
    }
};

extend(OrderOverview, ttPage);
window.page = new OrderOverview();

