/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


var gButtonClicked = null;
var gSB = null;
function AddressSelectDialog()
{
    ttDialog.call(this, "footer");
}
AddressSelectDialog.prototype =
{
    onLoad: function(params)
    {
        gSB = E("stringbundle");

        gAddress = params.address;
        if (params.address)
            setAddress(params.address);
        if (params.geo)
            setGeo(params.geo);
    },

    __end : null
}
extend(AddressSelectDialog, ttDialog);
var dialog = new AddressSelectDialog();


function setAddress(address)
{
    var r = "";

    if (address.name)
        r += address.name + "\n";
    if (address.street)
        r += address.street + (address.housenumber ? " " + address.housenumber : "") + "\n";
    if (address.city)
        r += (address.postcode ? address.postcode + " " : "") + address.city + "\n";
    if (address.country)
    {
        try {
            var sbC = getStringBundle("chrome://tthome/locale/ttlocalelist/countries.properties");
            r += sbC.GetStringFromName(address.country) + "\n";
        } catch (e) { unimportantError(e); }
    }
    if (address.addressname)
        r += gSB.getFormattedString("favLabel", [address.addressname]) + "\n";

    E("address").value = r;
}

function setGeo(address)
{
    gAddress = address;
    gSB = E("stringbundle");
    var r = "";

    if (address.name)
        r += address.name + "\n";
    if (address.lat != null)
        r += gSB.getFormattedString("latitudeLabel", [address.lat.toFixed(5)]) + "\n";
    if (address.long != null)
        r += gSB.getFormattedString("longitudeLabel", [address.long.toFixed(5)]) + "\n";

    E("address").value = r;
}

function showOnMap()
{
    dialog.close(1);
}

function navigateTo()
{
    dialog.close(2);
}

function addFav()
{
    if (!gAddress.addressname)
    {
        ttMessageService().prompt(
            gSB.getString("enterFavLabelTitle"),
            gSB.getString("enterFavLabelText"),
            null,
            null,
            null,
            function(value)
            {
                if (!value)
                {
                    error(gSB.getString("enterFavLabelNothingEntered"));
                    return;
                }

                gAddress.addressname = value;
                dialog.close(3);
            },
            function() {}
            );
    }
    else
        dialog.close(3);
}
