/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ConnectSDCard()
{
    ttPage.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/installSelectSome/connectSDCard.properties");
}

ConnectSDCard.prototype =
{
    _stringBundle : null,
    _canSkip : false,
    _device : null,

    inputOnLoad : function(params)
    {
        this._canSkip = params.canSkip;

        let tipMessage = this._stringBundle.GetStringFromName("page.sdcard.tip");
        let [beforeLink, linkLabel, afterLink]  = tipMessage.split(/\[\/?link\]/);
        let linkElement = E("tomtom-website");

        if (beforeLink)
            E("page-tip").insertBefore(document.createTextNode(beforeLink), linkElement);

        linkElement.setAttribute("label", linkLabel);

        if (afterLink)
            E("page-tip").insertBefore(document.createTextNode(afterLink), linkElement.nextSibling);

        if (!this._canSkip)
        {
            E("page-message").textContent = this._stringBundle.GetStringFromName("page.cannotskip.message");
            E("memorycard-warning").hidden = false;

            let footer = this._wizard()._wizfooter;
            footer.getRightButton().label = this._stringBundle.GetStringFromName("button.cancel.label");
        }

        this._device = gApplication.deviceManager.activeDevice;
        this.registerLocationObserver();
        window.addEventListener("unload", makeCallback(this, this.unregisterLocationObserver), false);
    },

    registerLocationObserver : function()
    {
        this._device.installLocations().addObserver(this);
    },

    unregisterLocationObserver : function()
    {
        try
        {
            this._device.installLocations().removeObserver(this);
        } catch (e) {
}
    },

    added : function(installLocation)
    {
        gApplication.deviceManager.resumeDeviceSelection(this._device, installLocation);
    },

    removed : function()
    {
    },

    repopulated : function()
    {
    },

    ejectDevice : function()
    {
        try {
            if (this._device)
                this._device.disconnect(false);
        } catch (e) {
            error(e);
        }
    },

    QueryInterface : function(iid)
    {
        if (iid.equals(CI.ttICollectionObserver) ||
            iid.equals(CI.nsISupportsWeakReference) ||
            iid.equals(CI.nsISupports))
            return this;
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    result : function()
    {
        if (!this._canSkip)
            return "abortConditional"

        return "";
    }
};
extend(ConnectSDCard, ttPage);
window.page = new ConnectSDCard();
