/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ShowLocalItems()
{
    ttSubTask.apply(this, arguments);
}
ShowLocalItems.prototype =
{
    name : "showLocalItems",

    start : function()
    {
        ttSubTask.prototype.start.apply(this, arguments);
        this.showItemsLoad();
    },

    showItemsLoad : function()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("showItems"),
            null,
            makeCallback(this, this.showItemsLoadAsync),
            null,
            makeCallback(this, this.showItemsDone)
            );
    },

    showItemsLoadAsync : function(page)
    {
        var itemlist = new ttItemList();
        itemlist.addFilter(new ttDuplicateFilter());
        itemlist.addFilter(new ttDependencyTreeBuilder());
        page.inputStart(itemlist);
        itemlist.addItemListFromDLL(gApplication.homeServices.localNavItems());
        page.inputDone();
    },

    showItemsDone : function(items)
    {
        this.subtaskDone(items);
    },

    __end : null
}
extend(ShowLocalItems, ttSubTask);
