/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function SelectInstall()
{
    ttPage.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/urlHandlerInstall/selectInstall.properties");
}
SelectInstall.prototype =
{
    _stringBundle : null,
    _skipAddonWarning : false,

    inputOnLoad : function(itemlist)
    {
        this._listbox = E("listbox");
        this._listbox.addObserver(this);
    },

    inputStart : function(itemlist)
    {
        this._listbox.addItemList(itemlist);
    },

    inputDone : function()
    {
        this.updateContinueButton();
    },

    addedListItem : function(listitem)
    {
        if (!listitem.disabled && !(listitem.modelitem instanceof ttAddon))
            listitem.selected = true;
        listitem.addToggleButton(
                this._stringBundle.GetStringFromName("install"),
                this._stringBundle.GetStringFromName("dontInstall"),
                makeCallback(this, this.showWarningMessage),
                makeCallback(this, this.updateContinueButton));
    },

    showWarningMessage : function(listitem)
    {
        if (listitem.modelitem instanceof ttAddon && !this._skipAddonWarning)
        {
            var me = this;
            var warningTitle = this._stringBundle.formatStringFromName("install.warning.title", [listitem.modelitem.name], 1);
            var warningText = this._stringBundle.formatStringFromName("install.warning.text", [listitem.modelitem.name], 1);
            var acceptLabel = this._stringBundle.GetStringFromName("warning.accept.label");
            var cancelLabel = this._stringBundle.GetStringFromName("warning.cancel.label");
            ttMessageService().confirm(warningTitle, warningText, cancelLabel, acceptLabel,
                function()
                {
                    me._skipAddonWarning = true;
                },
                function()
                {
                    listitem.selected = false;
                }
            );
        }
        this.updateContinueButton();
    },

    updateContinueButton : function()
    {
        this.allowContinue(this._listbox.selectedModelitems != 0);
    },

    result : function()
    {
        return this._listbox.selectedModelitems;
    }
}
extend(SelectInstall, ttPage);
window.page = new SelectInstall();
