/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ActivatePromotionCodeTask(arg)
{
    ttTask.apply(this, arguments);
}

ActivatePromotionCodeTask.prototype =
{
    name : "ActivatePromotionCodeTask",

    start : function(params)
    {
        ttTask.prototype.start.apply(this, arguments);

        if (params && params.activateLocalItems)
            this.loadSubTask(new ActivateLocalItem(), null, makeCallback(this, this.activateDone));
        else
            this.downloadPromotions();
    },

    activateDone : function(items)
    {
        if (items)
            this.installLoad(items);
        else
            this.downloadPromotions();
    },

    downloadPromotions : function()
    {
        this.loadSubTask(new DownloadPromotions(),
            null,
            makeCallback(this, this.downloadPromotionsDone)
        );
    },

    downloadPromotionsDone : function(items)
    {
        if (items.length == 0)
        {
this.taskDone();
            return;
        }

        this.installLoad(items);
    },

    installLoad : function(items)
    {
        this.loadSubTask(new InstallSelectSome(),
            { items: items, confirmSelection: true },
            makeCallback(this, this.installDone)
        );
    },

    installDone : function()
    {
        this.taskDone();
    },

    __end : null
}
extend(ActivatePromotionCodeTask, ttTask);
var task = new ActivatePromotionCodeTask();
