/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function MapFlavoursTask(arg)
{
    ttTask.apply(this, arguments);
}
MapFlavoursTask.prototype =
{
    name : "mapFlavours",
    origMap : null,
    devItems : null,
    resultCallback : null,

    start : function(args)
    {
        ttTask.prototype.start.apply(this, arguments);

        this.origMap = args.map;
        this.devItems = args.devItems;
        this.resultCallback = args.resultCallback;

        this.loadSubTask(new MapFlavours(),
            { item : this.origMap,
              insideInstallFlow : false,
              installedItems : [this.origMap],
              devItems : this.devItems,
              additionalSizeRequirements : null,
              freeSpaceBuffer : kFreeSpaceBuffer },
            makeCallback(this, this.flavourSelectionDone)
            );
    },

    flavourSelectionDone : function(flavour)
    {
        if (this.resultCallback)
        {
            this.taskDone();
            this.resultCallback(flavour);
            return;
        }

        if (!flavour || flavour.idstr == this.origMap.idstr)
        {
            this.taskDone();
            return;
        }

        this.loadSubTask(new InstallSelectSome(),
            { items: [flavour], confirmSelection: false },
            makeCallback(this, this.installDone)
            );
    },

    installDone : function()
    {
        this.taskDone();
    },

    __end : null
}
extend(MapFlavoursTask, ttTask);
var task = new MapFlavoursTask();
