/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function URLHandlerInstallTask(arg)
{
    ttTask.apply(this, arguments);
}
URLHandlerInstallTask.prototype =
{
    name : "URLHandlerInstall",

    init : function()
    {
        ttTask.prototype.init.apply(this, arguments);
        this.urlHandlerInstall = new URLHandlerInstall();
        this.checkout = new Checkout();
        this.install = new InstallSelectSome();
    },

    start : function(args)
    {
        ttTask.prototype.start.apply(this, arguments);

        this.loadSubTask(this.urlHandlerInstall,
            args,
            makeCallback(this, this.urlHandlerInstallDone)
            );
    },

    urlHandlerInstallDone : function(items)
    {
        for (var i = 0; i < items.length; i++)
        {
            var item = items[i];
            if (item.price && !item.price.free)
                gApplication.cart.addItem(item);
        }
        if (gApplication.cart.isEmpty)
        {
            this.installLoad(items, false);
        }
        else
        {
            this.checkoutLoad();
        }
    },

    checkoutLoad : function()
    {
        this.loadSubTask(this.checkout, null,
            makeCallback(this, this.checkoutDone)
            );
    },
    checkoutDone : function(items)
    {
        this.installLoad(items, true);
    },

    installLoad : function(items, confirmSelect)
    {
        for (var i = 0; i < items.length; i++)
        {
            if (items[i].hasNoDownload)
            {
                items.splice(i, 1);
                i--;
            }
        }

        if (items.length == 0)
        {
this.taskDone();
            return;
        }

        this.loadSubTask(this.install,
            { items: items, confirmSelection: confirmSelect },
            makeCallback(this, this.installDone)
            );
    },
    installDone : function(items)
    {
        this.taskDone();
    },

    __end : null
}
extend(URLHandlerInstallTask, ttTask);
var task = new URLHandlerInstallTask();
