/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


var stringbundle = getStringBundle("chrome://tthome/locale/ui/dashboard/dashboard.properties");

var deviceObserver =
{
    changed: function(deviceChanged, locationChanged)
    {
        if (!deviceChanged)
            return;

        var dashboard = E("main-dashboard");
        var dev = gApplication.deviceManager.activeDevice;
        if (dev)
        {
            var modelType = dev.model.familyName;
            modelType = modelType.replace(/\s/, "\xA0");

            dashboard.buttonsById["content-list-updatedevice"]
                     .setAttribute("label", stringbundle.formatStringFromName("updateDashButtonConnected", [modelType], 1));
            dashboard.buttonsById["content-list-readman"]
                     .setAttribute("label", stringbundle.formatStringFromName("readDashButtonConnected", [modelType], 1));
            dashboard.buttonsById["content-list-operatego"]
                     .setAttribute("label", stringbundle.formatStringFromName("operateDashButtonConnected", [modelType], 1));
            dashboard.buttonsById["content-list-manageitems"]
                     .setAttribute("label", stringbundle.formatStringFromName("manageDashButtonConnected", [modelType], 1));
            dashboard.buttonsById["content-list-buyaccessories"]
                     .setAttribute("label", stringbundle.formatStringFromName("buyAccessoriesButtonConnected", [modelType], 1));
        }
        else
        {
            dashboard.buttonsById["content-list-updatedevice"]
                     .setAttribute("label", stringbundle.GetStringFromName("updateDashButton"));
            dashboard.buttonsById["content-list-readman"]
                     .setAttribute("label", stringbundle.GetStringFromName("readDashButton"));
            dashboard.buttonsById["content-list-operatego"]
                     .setAttribute("label", stringbundle.GetStringFromName("operateDashButton"));
            dashboard.buttonsById["content-list-manageitems"]
                     .setAttribute("label", stringbundle.GetStringFromName("manageDashButton"));
            dashboard.buttonsById["content-list-buyaccessories"]
                     .setAttribute("label", stringbundle.GetStringFromName("buyAccessoriesButton"));
        }
        dashboard.buttonsById["content-list-joinmapshare"].hidden = !dev || (dev.mapShare && dev.mapShare.mapPatchDownloadsEnabled);
        dashboard.refreshVisibleButtons();
    }
}

window.onload = function()
{
    deviceObserver.changed(true, false);
    gApplication.deviceManager.addObserver(deviceObserver);
}

window.onunload = function()
{
    gApplication.deviceManager.removeObserver(deviceObserver);
}
function planRouteOnline()
{
    launchSystemBrowserWithStaticURL(idMapping["onlineplanner"], null, null);
}

