/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


var gSerial = null;
var gDeviceCode = null;

var observer =
{
    changed: function(deviceChanged, locationChanged)
    {
        window.deviceChanged();
    }
};
function DeviceRequiredDialog()
{
    ttDialog.call(this, "footer");
}
DeviceRequiredDialog.prototype =
{
    onLoad: function(params)
    {
        gApplication.deviceManager.addObserver(observer);

        if (params && (params.specificDeviceSerial || params.specificDeviceDeviceCode))
        {
            setSpecificDevice(
                params.specificDeviceSerial,
                params.specificDeviceDeviceCode,
                params.specificDeviceModelName);
        }
        deviceChanged();
    },
close : function(selectDevice)
    {
        gApplication.deviceManager.removeObserver(observer);
        gApplication.deviceManager.resumeDeviceSelection(selectDevice);
        var result;
        if (selectDevice)
            result = (gApplication.deviceManager.activeDevice == selectDevice);
        else
            result = (gApplication.deviceManager.activeDevice != null);
        ttDialog.prototype.close.call(this, result);
    },

    __end : null
}
extend(DeviceRequiredDialog, ttDialog);
var dialog = new DeviceRequiredDialog();
function setSpecificDevice(serial, deviceCode, modelName)
{
    E("dev-model").value = modelName;
    E("dev-serial").value = serial;
    E("dev-devicecode").value = deviceCode;
    E("specificDeviceBox").hidden = false;
    gDeviceCode = deviceCode;
    gSerial = serial;
    if (gDeviceCode || gSerial)
    {
        gApplication.deviceManager.pauseDeviceSelection();
    }
}

function deviceChanged()
{
    if (gSerial || gDeviceCode)
    {
        var devs = gApplication.deviceManager.getAllDevices();
        for (var i = 0; i < devs.length; i++)
        {
            var dev = devs[i];
            if (gDeviceCode && dev.deviceCode == gDeviceCode ||
                gSerial && dev.serial == gSerial)
            {
                dialog.close(dev);
                return;
            }
        }
    }
    else
    {
        if (gApplication.deviceManager.activeDevice)
        {
            dialog.close(null);
            return;
        }
    }
}
