/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function AddGoInfoDialog()
{
    ttDialog.call(this, "footer");
}
AddGoInfoDialog.prototype =
{
    _devicePath : null,

    onLoad: function(params)
    {
        setType(params.type);
    },

    continue : function()
    {
        exploreDeviceFolder(this._devicePath);
    },

    __end : null
}
extend(AddGoInfoDialog, ttDialog);
var dialog = new AddGoInfoDialog();
function exploreDeviceFolder(folder)
{
    var dir = gApplication.deviceManager.activeInstallLocation.path.clone();
    if (folder)
    {
        var folders = folder.split("/");
        for (var i = 0; i < folders.length; i++)
        {
            dir.append(folders[i]);
        }
    }
    dir = ensureDirExists(dir);{}
dir.QueryInterface(CI.nsILocalFile).reveal();
}
function setType(type){

    var stringBundle = E("stringbundle");
    var htmlFilePath = null;
    var devicePathToOpen = null;

    if (type == "music")
    {
        htmlFilePath = "chrome://tthome/locale/pages/music.xhtml";
        devicePathToOpen = 'mp3';
    }
    else if (type == "photos")
    {
        htmlFilePath = "chrome://tthome/locale/pages/photos.xhtml";
        devicePathToOpen = 'photos';
    }
    else if (type == "documents")
    {
        htmlFilePath = "chrome://tthome/locale/pages/documents.xhtml";
        devicePathToOpen = 'text';
    }
    setContenttype(type);
    setTitle(stringBundle.getString(type + ".title"));
    setSubtitle(stringBundle.getString(type + ".subtitle"));
    setHTMLFilePath(htmlFilePath);
    dialog._devicePath = devicePathToOpen;
}
function setContenttype(type){
    E("message-header").setAttribute("contenttype", type);
}
function setTitle(title){
    E("message-header").setAttribute("title", title);
}
function setSubtitle(subtitle){
    E("message-header").subtitle = subtitle;
}
function setHTMLFilePath(adress){
    E("html-frame").setAttribute("src", adress);
}
