/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function RatingDialog()
{
    ttDialog.call(this, "page-footer");
}
RatingDialog.prototype =
{
    _success: false,

    onLoad : function (params)
    {
        try
        {
            var item = params.item;
            var rating = params.rating;

            var dev = (gApplication.deviceManager.activeDevice || gApplication.deviceManager.lastDevice);

            var me = this;
            this.networkCall(rpc.call("sharing", "rateItem",
                {
                    deviceserial: dev.serial,
                    devicecode: dev.deviceCode,
                    devicemodel: dev.model.id,
                    item: item.idurl,
                    rating: rating
                }, null, RPC.METHOD_POST,
                function ()
                {
                    me._success = true;
                    E("message-container").hidden = false;
                    E("page-footer").getRightButton().disabled = false;
                },
                function (e)
                {
                    error(e);
                    me.close(false);
                }));
        }
        catch (e)
        {
            error(e);
            this.close(false);
        }
    },

    cancel : function ()
    {
        this.close(this._success);
    }
};
extend(RatingDialog, ttDialog);
var dialog = new RatingDialog();
