/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function onLoad()
{
    try {
        if (window.arguments && window.arguments[0])
        {
            var mainWin = gApplication.getSomeMainWindow();
            if (mainWin)
            {
                runAsync(function() window.close(), 0);
                mainWin.handleWindowArgs(window.arguments);
                return;
            }
        }
    } catch (e) { error(e); }

    E("browser").addEventListener("DOMTitleChanged", onTitleChange, false);
}

var defaultTitle = null;
function onTitleChange(event)
{
    if (!defaultTitle)
        defaultTitle = document.documentElement.getAttribute("title");

    var title = E("browser").contentDocument.title;
    title = (title ? title + " - " + defaultTitle : defaultTitle);
    document.documentElement.setAttribute("title", title);
}

function doBack(event)
{
    E("browser").goBack();
}
function doForward(event)
{
    E("browser").goForward();
}
function doReload(event)
{
    E("browser").reload();
}
