/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ShareContentTask(arg)
{
    ttTask.apply(this, arguments);
}

ShareContentTask.prototype =
{
    name : "ShareContentTask",
    contentType : null,

    init : function()
    {
        ttTask.prototype.init.apply(this, arguments);
    },

    start : function (aArgs)
    {
        ttTask.prototype.start.apply(this, arguments);

        if (aArgs && aArgs.contentType)
            this.contentType = aArgs.contentType;

        this.loadSubTask(new ShareContent(), null, makeCallback(this, this.shareContentDone));
    },

    shareContentDone : function (aItems)
    {
        this.taskDone();
    },
    
    _loggedOut : function ()
    {
        let sb = getStringBundle("chrome://tthome/locale/ui/subtask/shareContent/shareContent.properties");
                 ttMessageService().alert(sb.GetStringFromName("userLoggedOut.title"),
                                          sb.GetStringFromName("userLoggedOut.message"));
    },
    
    _usernameChanged : function ()
    {
    },

    __end : null
}
extend(ShareContentTask, ttTask);
var task = new ShareContentTask();
